Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 858)
@@ -19,4 +19,5 @@
    USE trp_trc
    USE sms
+   USE prtctl_trc
 
    IMPLICIT NONE
@@ -24,4 +25,8 @@
 
    PUBLIC   p4z_flx    ! called in p4zprg.F90
+
+   REAL(wp) :: &  ! pre-industrial atmospheric [co2] (ppm) 	
+     atcox = 0.20946
+
 
    !!* Substitution
@@ -35,5 +40,5 @@
 CONTAINS
 
-   SUBROUTINE p4z_flx
+   SUBROUTINE p4z_flx ( kt )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE p4z_flx  ***
@@ -43,9 +48,12 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jrorr
-      REAL(wp) ::   zpdtan, zttc, zws
+      INTEGER, INTENT(in) :: kt
+      INTEGER  ::   ji, jj, jrorr, nspyr
+      REAL(wp) ::   zttc, zws
       REAL(wp) ::   zfld, zflu, zoxy16, zflu16, zfact
       REAL(wp) ::   zph, zah2, zbot, zdic, zalk, zschmitto2, zalka, zschmittco2
-      REAL(wp), DIMENSION(jpi,jpj) ::   zkgco2, zkgo2, zh2co3
+      REAL(wp), DIMENSION(jpi,jpj) ::   zkgco2, zkgo2, zh2co3, zqcumtemp 
+      CHARACTER (len=25) :: charout
+
       !!---------------------------------------------------------------------
 
@@ -55,5 +63,5 @@
       ! -----------------------------------------------------
 
-      zpdtan = raass / rdt
+      nspyr = INT( raass / rdt )
 
       ! SURFACE CHEMISTRY (PCO2 AND [H+] IN
@@ -63,5 +71,7 @@
       DO jrorr = 1, 10
 
+!CDIR NOVERRCHK
          DO jj = 1, jpj
+!CDIR NOVERRCHK
             DO ji = 1, jpi
 
@@ -94,5 +104,7 @@
       ! -------------------------------------------
 
-      DO jj = 1, jpj
+!CDIR NOVERRCHK
+      DO jj = 1, jpj
+!CDIR NOVERRCHK
          DO ji = 1, jpi
 
@@ -140,12 +152,15 @@
       END DO
 
+      zqcumtemp(:,:) = 0.
       DO jj = 1, jpj
          DO ji = 1, jpi
 
             ! Compute CO2 flux for the sea and air
-            zfld = atcco2 * tmask(ji,jj,1) * chemc(ji,jj,3) * zkgco2(ji,jj)
+            zfld = atcco2 * tmask(ji,jj,1) * chemc(ji,jj,1) * zkgco2(ji,jj)
             zflu = zh2co3(ji,jj) * tmask(ji,jj,1) * zkgco2(ji,jj)
             tra(ji,jj,1,jpdic) = tra(ji,jj,1,jpdic) + ( zfld - zflu ) / fse3t(ji,jj,1)
 
+            zqcumtemp(ji,jj) = ( zfld - zflu ) * rfact &
+               &             * e1t(ji,jj) * e2t(ji,jj) * tmask(ji,jj,1) * 1000.
             ! Compute O2 flux 
             zoxy16 = trn(ji,jj,1,jpoxy)
@@ -158,9 +173,33 @@
             trc2d(ji,jj,2) = zflu16 * 1000.
             trc2d(ji,jj,3) = zkgco2(ji,jj)
-            trc2d(ji,jj,4) = atcco2 - zh2co3(ji,jj) / ( chemc(ji,jj,3) + rtrn )
+            trc2d(ji,jj,4) = atcco2 - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn )
 # endif
          END DO
       END DO
       !
+
+      DO jj = 1, jpj
+        DO ji = 1, jpi
+           qcumul(1) = qcumul(1) + zqcumtemp(ji,jj) * tmask_i(ji,jj)
+        END DO
+      END DO
+
+      IF( MOD( kt, nspyr ) == 0 ) THEN
+        WRITE(numout,*) ' Atmospheric pCO2    :'
+        WRITE(numout,*) '-------------------- : ',kt,'  ',atcco2
+        WRITE(numout,*) '(ppm)'
+        WRITE(numout,*) 'Total Flux of Carbon :'
+        WRITE(numout,*) '-------------------- : ',qcumul(1)*12./1E15
+        WRITE(numout,*) '(GtC/an)'
+        qcumul(1) = 0.
+      ENDIF
+
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('flx ')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
+
    END SUBROUTINE p4z_flx
 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zlim.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 858)
@@ -44,4 +44,5 @@
       REAL(wp) ::   zlim1, zlim2, zlim3, zlim4, zno3, zferlim
       REAL(wp) ::   zconctemp, zconctemp2, zconctempn, zconctempn2
+      REAL(wp) ::   ztemp, zdenom
       !!---------------------------------------------------------------------
 
@@ -70,12 +71,12 @@
             DO ji = 1, jpi
                zconctemp   = MAX( 0.e0 , trn(ji,jj,jk,jpdia)-5e-7 )
-               zconctemp2  = MIN( 5.e-7, trn(ji,jj,jk,jpdia)      )
+               zconctemp2  = trn(ji,jj,jk,jpdia) - zconctemp
                zconctempn  = MAX( 0.e0 , trn(ji,jj,jk,jpphy)-1e-6 )
-               zconctempn2 = MIN( 1.e-6, trn(ji,jj,jk,jpphy)      )
+               zconctempn2 = trn(ji,jj,jk,jpphy) - zconctempn
                concdfe(ji,jj,jk) = ( zconctemp2 * conc3 + 0.4e-9 * zconctemp)   &
-                  &              / ( zconctemp2 + zconctemp + rtrn )
+                  &              / ( trn(ji,jj,jk,jpdia) + rtrn )
                concdfe(ji,jj,jk) = MAX( conc3, concdfe(ji,jj,jk) )
                concnfe(ji,jj,jk) = ( zconctempn2 * conc2 + 0.08e-9 * zconctempn)   &
-                  &              / ( zconctempn2 + zconctempn + rtrn )
+                  &              / ( trn(ji,jj,jk,jpphy) + rtrn )
                concnfe(ji,jj,jk) = MAX( conc2, concnfe(ji,jj,jk) )
             END DO
@@ -90,11 +91,9 @@
 !      Small flagellates
 !      -----------------------------------------------
+              zdenom = 1. / &
+                  & ( conc0 * concnnh4 + concnnh4 * trn(ji,jj,jk,jpno3) + conc0 * trn(ji,jj,jk,jpnh4) )
+               xnanono3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * concnnh4 * zdenom
+               xnanonh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * conc0    * zdenom
 
-               xnanono3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * concnnh4           &
-                  &               / ( conc0 * concnnh4 + concnnh4 * trn(ji,jj,jk,jpno3)   &
-                  &                                    + conc0    * trn(ji,jj,jk,jpnh4) )
-               xnanonh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * conc0              &
-                  &               / ( conc0 * concnnh4 + concnnh4 * trn(ji,jj,jk,jpno3)   &
-                  &                                    + conc0    * trn(ji,jj,jk,jpnh4) )
                zlim1 = xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk)
                zlim2 = trn(ji,jj,jk,jppo4) / ( trn(ji,jj,jk,jppo4) + concnnh4          ) 
@@ -116,11 +115,9 @@
 !   Michaelis-Menten Limitation term for nutrients Diatoms
 !   ----------------------------------------------
+              zdenom = 1. / &
+                  & ( conc1 * concdnh4 + concdnh4 * trn(ji,jj,jk,jpno3) + conc1 * trn(ji,jj,jk,jpnh4) )
 
-               xdiatno3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * concdnh4                         &
-                  &               / ( conc1  * concdnh4 + concdnh4 * trn(ji,jj,jk,jpno3)   &
-                  &                                     + conc1    * trn(ji,jj,jk,jpnh4) )
-               xdiatnh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * conc1                            &
-                  &               / ( conc1  * concdnh4 + concdnh4 * trn(ji,jj,jk,jpno3)   &
-                  &                                     + conc1   * trn(ji,jj,jk,jpnh4) )
+               xdiatno3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * concdnh4 * zdenom
+               xdiatnh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * conc1    * zdenom 
 
                zlim1 = xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk)
@@ -130,4 +127,21 @@
                xlimdia(ji,jj,jk) = MIN( zlim1, zlim2, zlim3, zlim4 )
 
+            END DO
+         END DO
+      END DO
+
+
+      ! Compute the fraction of nanophytoplankton that is made of calcifiers
+      ! --------------------------------------------------------------------
+
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ztemp = MAX( 0., tn(ji,jj,jk) )
+               xfracal(ji,jj,jk) = caco3r * xlimphy(ji,jj,jk)   &
+                  &                       * MAX( 0.0001, ztemp / ( 2.+ ztemp ) )   &
+                  &                       * MAX( 1., trn(ji,jj,jk,jpphy) * 1.e6 / 2. )
+               xfracal(ji,jj,jk) = MIN( 0.8 , xfracal(ji,jj,jk) )
+               xfracal(ji,jj,jk) = MAX( 0.01, xfracal(ji,jj,jk) )
             END DO
          END DO
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 858)
@@ -19,4 +19,5 @@
    USE trp_trc
    USE sms
+   USE prtctl_trc
 
    IMPLICIT NONE
@@ -24,4 +25,9 @@
 
    PUBLIC   p4z_lys    ! called in p4zprg.F90
+
+   !! * Module variables
+
+   REAL(wp) :: &
+      calcon = 1.03E-2        ! mean calcite concentration [Ca2+] in sea water [mole/kg solution]
 
    !!----------------------------------------------------------------------
@@ -48,4 +54,5 @@
       REAL(wp) ::   zomegaca, zexcess, zexcess0
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zco3
+      CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
@@ -57,6 +64,9 @@
       DO jn = 1, 5                               !  BEGIN OF ITERATION
          !
+!CDIR NOVERRCHK
          DO jk = 1, jpkm1
+!CDIR NOVERRCHK
             DO jj = 1, jpj
+!CDIR NOVERRCHK
                DO ji = 1, jpi
 
@@ -131,9 +141,15 @@
 
 # if defined key_trc_dia3d
-         trc3d(:,:,:,1) = rhop(:,:,:)
+         trc3d(:,:,:,1) = hi(:,:,:)
          trc3d(:,:,:,2) = zco3(:,:,:)
          trc3d(:,:,:,3) = aksp(:,:,:) / calcon
 # endif
       !
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('lys ')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
    END SUBROUTINE p4z_lys
 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zmeso.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 858)
@@ -16,4 +16,5 @@
    USE trp_trc         ! 
    USE sms             ! 
+   USE prtctl_trc
 
    IMPLICIT NONE
@@ -40,7 +41,15 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zcompadi, zcompaph, zcompapoc, zcompaz
-      REAL(wp) ::   zfact, zstep, zcompam, zdenom, zgraze2
+      INTEGER  :: ji, jj, jk
+      REAL(wp) :: zcompadi, zcompaph, zcompapoc, zcompaz
+      REAL(wp) :: zfact, zstep, zcompam, zdenom, zgraze2
+      REAL(wp) :: zgrarem2, zgrafer2, zgrapoc2, zprcaca, zmortz2
+#if defined key_kriest
+      REAL znumpoc
+#endif
+      REAL(wp),DIMENSION(jpi,jpj,jpk) :: zrespz2,ztortz2,zgrazd,zgrazz,zgrazpof
+      REAL(wp),DIMENSION(jpi,jpj,jpk) :: zgrazn,zgrazpoc,zgraznf,zgrazf
+      REAL(wp),DIMENSION(jpi,jpj,jpk) :: zgrazfff,zgrazffe
+      CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
@@ -60,6 +69,6 @@
 !     Respiration rates of both zooplankton
 !     -------------------------------------
-               respz2(ji,jj,jk) = resrat2 * zfact * ( 1. + 3. * nitrfac(ji,jj,jk) )        &
-                  &             * trn(ji,jj,jk,jpmes) / ( xkmort + trn(ji,jj,jk,jpmes) )
+               zrespz2(ji,jj,jk)  = resrat2 * zfact * ( 1. + 3. * nitrfac(ji,jj,jk) )        &
+                  &       * trn(ji,jj,jk,jpmes) / ( xkmort + trn(ji,jj,jk,jpmes) )
 
 !     Zooplankton mortality. A square function has been selected with
@@ -67,5 +76,5 @@
 !     mimic predation.
 !     ---------------------------------------------------------------
-               tortz2(ji,jj,jk) = mzrat2 * 1.e6 * zfact * trn(ji,jj,jk,jpmes)
+               ztortz2(ji,jj,jk) = mzrat2 * 1.e6 * zfact * trn(ji,jj,jk,jpmes)
                !
             END DO
@@ -73,8 +82,8 @@
       END DO
 
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
+
+      DO jk = 1,jpkm1
+         DO jj = 1,jpj
+            DO ji = 1,jpi
                zcompadi  = MAX( ( trn(ji,jj,jk,jpdia) - 1.e-8 ), 0.e0 )
                zcompaz   = MAX( ( trn(ji,jj,jk,jpzoo) - 1.e-8 ), 0.e0 )
@@ -95,32 +104,28 @@
                   &     * trn(ji,jj,jk,jpmes)
 
-               grazd  (ji,jj,jk) = zgraze2 * xprefc   * zcompadi
-               grazz  (ji,jj,jk) = zgraze2 * xprefz   * zcompaz
-               grazn  (ji,jj,jk) = zgraze2 * xprefp   * zcompaph
-               grazpoc(ji,jj,jk) = zgraze2 * xprefpoc * zcompapoc
-
-               graznf (ji,jj,jk) = grazn  (ji,jj,jk) * trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)
-
-               graznch(ji,jj,jk) = grazn  (ji,jj,jk) * trn(ji,jj,jk,jpnch) / (trn(ji,jj,jk,jpphy) + rtrn)
-
-               grazs  (ji,jj,jk) = grazd  (ji,jj,jk) * trn(ji,jj,jk,jpbsi) / (trn(ji,jj,jk,jpdia) + rtrn)
-
-               grazf  (ji,jj,jk) = grazd  (ji,jj,jk) * trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)
-
-               grazdch(ji,jj,jk) = grazd  (ji,jj,jk) * trn(ji,jj,jk,jpdch) / (trn(ji,jj,jk,jpdia) + rtrn)
-
-               grazpof(ji,jj,jk) = grazpoc(ji,jj,jk) * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
-            END DO
-         END DO
-      END DO
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
+               zgrazd(ji,jj,jk)   = zgraze2 * xprefc   * zcompadi
+               zgrazz(ji,jj,jk)   = zgraze2 * xprefz   * zcompaz
+               zgrazn(ji,jj,jk)   = zgraze2 * xprefp   * zcompaph
+               zgrazpoc(ji,jj,jk) = zgraze2 * xprefpoc * zcompapoc
+
+               zgraznf(ji,jj,jk)  = zgrazn(ji,jj,jk)   * trn(ji,jj,jk,jpnfe) &
+                  &                                     / (trn(ji,jj,jk,jpphy) + rtrn)
+               zgrazf(ji,jj,jk)   = zgrazd(ji,jj,jk)   * trn(ji,jj,jk,jpdfe) &
+                  &                                    / (trn(ji,jj,jk,jpdia) + rtrn)
+               zgrazpof(ji,jj,jk) = zgrazpoc(ji,jj,jk) * trn(ji,jj,jk,jpsfe) &
+                  &                                   / (trn(ji,jj,jk,jppoc) + rtrn)
+            END DO
+         END DO
+      END DO
+      
+      
+      DO jk = 1,jpkm1
+         DO jj = 1,jpj
+            DO ji = 1,jpi
+               
 !    Mesozooplankton flux feeding on GOC
 !    ----------------------------------
 # if ! defined key_kriest
-               grazffe(ji,jj,jk) = 5.e3 * zstep * wsbio4(ji,jj,jk)          &
+               zgrazffe(ji,jj,jk) = 5.e3 * zstep * wsbio4(ji,jj,jk)          &
 #  if defined key_off_degrad
                   &     * facvol(ji,jj,jk)          &
@@ -128,9 +133,9 @@
                   &     * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpmes)
 
-               grazfff(ji,jj,jk) = grazffe(ji,jj,jk)         &
+               zgrazfff(ji,jj,jk) = zgrazffe(ji,jj,jk)       &
                   &     * trn(ji,jj,jk,jpbfe) / (trn(ji,jj,jk,jpgoc) + rtrn)
 # else
 ! KRIEST3
-               grazffe(ji,jj,jk) = 0.5 * 1.3e-2 / 5.5e-7 * 0.3 * zstep * wsbio3(ji,jj,jk)     &
+               zgrazffe(ji,jj,jk) = 0.5 * 1.3e-2 / 5.5e-7 * 0.3 * zstep * wsbio3(ji,jj,jk)     &
                   &     * tgfunc(ji,jj,jk) * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpmes)    &
 #  if defined key_off_degrad
@@ -139,5 +144,5 @@
                   &     /  (trn(ji,jj,jk,jppoc) * 1.e7 + 0.1)
 
-!!C        grazffe(ji,jj,jk) = 5.e3 * zstep * wsbio3(ji,jj,jk)
+!!C        zgrazffe(ji,jj,jk) = 5.e3 * zstep * wsbio3(ji,jj,jk)
 !!C     &     * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpmes)
 !!C#    if defined key_off_degrad
@@ -145,7 +150,55 @@
 !!C#    endif
 
-               grazfff(ji,jj,jk) = grazffe(ji,jj,jk)       &
+               zgrazfff(ji,jj,jk) = zgrazffe(ji,jj,jk)      &
                   &     * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
 # endif
+            END DO
+         END DO
+      END DO
+      
+
+      DO jk = 1,jpkm1
+         DO jj = 1,jpj
+            DO ji = 1,jpi
+
+!    Mesozooplankton efficiency
+!    --------------------------
+               zgrarem2 = ( zgrazd(ji,jj,jk) + zgrazz(ji,jj,jk) + zgrazn(ji,jj,jk) &
+                  &            + zgrazpoc(ji,jj,jk) + zgrazffe(ji,jj,jk) )   &
+                  &     * ( 1. - epsher2 - unass2 )
+#if ! defined key_kriest
+               zgrafer2 = (zgrazf(ji,jj,jk) + zgraznf(ji,jj,jk) + zgrazz(ji,jj,jk) &
+                  &     * ferat3 + zgrazpof(ji,jj,jk) + zgrazfff (ji,jj,jk))*(1.-epsher2-unass2) &
+                  &       + epsher2 * ( &
+                  &      zgrazd(ji,jj,jk)   * MAX((trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)-ferat3),0.) &
+                  &    + zgrazn(ji,jj,jk)   * MAX((trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)-ferat3),0.) &
+                  &    + zgrazpoc(ji,jj,jk) * MAX((trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)-ferat3),0.) &
+                  &    + zgrazffe(ji,jj,jk) * MAX((trn(ji,jj,jk,jpbfe) / (trn(ji,jj,jk,jpgoc) + rtrn)-ferat3),0.)  )
+#else
+               zgrafer2 = (zgrazf(ji,jj,jk) + zgraznf(ji,jj,jk) + zgrazz(ji,jj,jk) &
+                  &       * ferat3 + zgrazpof(ji,jj,jk) + zgrazfff(ji,jj,jk) )*(1.-epsher2-unass2) &
+                  &       + epsher2 * ( &
+                  &      zgrazd(ji,jj,jk)   * MAX((trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)-ferat3),0.) &
+                  &    + zgrazn(ji,jj,jk)   * MAX((trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)-ferat3),0.) &
+                  &    + zgrazpoc(ji,jj,jk) * MAX((trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)-ferat3),0.) &
+                  &    + zgrazffe(ji,jj,jk) * MAX((trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)-ferat3),0.)  )
+
+#endif
+               zgrapoc2 = (zgrazd(ji,jj,jk) + zgrazz(ji,jj,jk)  + zgrazn(ji,jj,jk) &
+                  &          + zgrazpoc(ji,jj,jk) + zgrazffe(ji,jj,jk)) * unass2
+
+               tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + zgrarem2 * sigma2
+               tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) + zgrarem2 * sigma2
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zgrarem2 * (1.-sigma2)
+               tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2ut * zgrarem2 * sigma2
+               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zgrafer2
+               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + zgrarem2 * sigma2
+               
+#if defined key_kriest
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zgrapoc2
+               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + zgrapoc2 * xkr_nmeso
+#else
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zgrapoc2
+#endif
             END DO
          END DO
@@ -155,44 +208,62 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-
-!    Mesozooplankton efficiency
-!    --------------------------
-               grarem2(ji,jj,jk) = (grazd(ji,jj,jk) + grazz(ji,jj,jk)              &
-                  &     + grazn(ji,jj,jk) + grazpoc(ji,jj,jk) + grazffe(ji,jj,jk))   &
-                  &     * (1.-epsher2-unass2)
-#if ! defined key_kriest
-               grafer2(ji,jj,jk) = (grazf(ji,jj,jk) + graznf(ji,jj,jk)                       &
-                  &     + grazz(ji,jj,jk) * ferat3 + grazpof(ji,jj,jk)                       &
-                  &     + grazfff(ji,jj,jk)) * (1.-epsher2-unass2)                       &
-                  &     + epsher2 * (grazd(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)                       &
-                  &    -ferat3),0.) + grazn(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)                       &
-                  &    -ferat3),0.) + grazpoc(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)                       &
-                  &    -ferat3),0.) + grazffe(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpbfe) / (trn(ji,jj,jk,jpgoc) + rtrn)                       &
-                  &    -ferat3),0.) )
-#else
-               grafer2(ji,jj,jk) = (grazf(ji,jj,jk) + graznf(ji,jj,jk)                       &
-                  &     + grazz(ji,jj,jk) * ferat3 + grazpof(ji,jj,jk)                       &
-                  &     + grazfff(ji,jj,jk)) * (1.-epsher2-unass2)                       &
-                  &     + epsher2 * (grazd(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)                       &
-                  &    -ferat3),0.) + grazn(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)                       &
-                  &    -ferat3),0.) + grazpoc(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)                       &
-                  &    -ferat3),0.) + grazffe(ji,jj,jk) * MAX(                       &
-                  &    (trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)                       &
-                  &    -ferat3),0.) )
-#endif
-               grapoc2(ji,jj,jk) = (grazd(ji,jj,jk) + grazz(ji,jj,jk)                     &
-                  &     + grazn(ji,jj,jk) + grazpoc(ji,jj,jk) + grazffe(ji,jj,jk)) * unass2
                !
+               !   Update the arrays TRA which contain the biological sources and sinks
+               !   --------------------------------------------------------------------
+               zmortz2 = ztortz2(ji,jj,jk) + zrespz2(ji,jj,jk)
+               tra(ji,jj,jk,jpmes) = tra(ji,jj,jk,jpmes) - zmortz2  &
+                  &    + epsher2 * ( zgrazd(ji,jj,jk) + zgrazz(ji,jj,jk) + zgrazn(ji,jj,jk) &
+                  &                 + zgrazpoc(ji,jj,jk) + zgrazffe(ji,jj,jk) )
+               tra(ji,jj,jk,jpdia) = tra(ji,jj,jk,jpdia) - zgrazd(ji,jj,jk)
+               tra(ji,jj,jk,jpzoo) = tra(ji,jj,jk,jpzoo) - zgrazz(ji,jj,jk)
+               tra(ji,jj,jk,jpphy) = tra(ji,jj,jk,jpphy) - zgrazn(ji,jj,jk)
+               tra(ji,jj,jk,jpnch) = tra(ji,jj,jk,jpnch) - zgrazn(ji,jj,jk) * trn(ji,jj,jk,jpnch)  &
+                  &                 / ( trn(ji,jj,jk,jpphy) + rtrn )
+               tra(ji,jj,jk,jpdch) = tra(ji,jj,jk,jpdch) - zgrazd(ji,jj,jk) * trn(ji,jj,jk,jpdch) &
+                  &                / ( trn(ji,jj,jk,jpdia) + rtrn )
+               tra(ji,jj,jk,jpbsi) = tra(ji,jj,jk,jpbsi) - zgrazd(ji,jj,jk) * trn(ji,jj,jk,jpbsi) &
+                  &                / ( trn(ji,jj,jk,jpdia) + rtrn )
+               tra(ji,jj,jk,jpdsi) = tra(ji,jj,jk,jpdsi) +  zgrazd(ji,jj,jk) * trn(ji,jj,jk,jpbsi) &
+                  &                / ( trn(ji,jj,jk,jpdia) + rtrn )
+               tra(ji,jj,jk,jpnfe) = tra(ji,jj,jk,jpnfe) -  zgraznf(ji,jj,jk)
+               tra(ji,jj,jk,jpdfe) = tra(ji,jj,jk,jpdfe) -  zgrazf(ji,jj,jk)
+
+               zprcaca = xfracal(ji,jj,jk) * part * unass2 * zgrazn(ji,jj,jk)
+
+               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprcaca
+               tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - 2. * zprcaca
+               tra(ji,jj,jk,jpcal) = tra(ji,jj,jk,jpcal) + zprcaca
+#if defined key_kriest
+               znumpoc = trn(ji,jj,jk,jpnum) / ( trn(ji,jj,jk,jppoc) + rtrn )
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zmortz2  &
+                  &                 - zgrazpoc(ji,jj,jk) - zgrazffe(ji,jj,jk)    
+               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) - zgrazpoc(ji,jj,jk) * znumpoc &
+                  &                  + zmortz2  * xkr_nmeso &
+                  &                  - zgrazffe(ji,jj,jk)   * znumpoc * wsbio4(ji,jj,jk) &
+                  &                  / ( wsbio3(ji,jj,jk) + rtrn )
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ferat3 * zmortz2 &
+               &                    + unass2 * ( ferat3 * zgrazz(ji,jj,jk) + zgraznf(ji,jj,jk) &
+               &                    + zgrazf(ji,jj,jk) + zgrazpof(ji,jj,jk) + zgrazfff(ji,jj,jk) ) &
+               &                    - zgrazfff(ji,jj,jk) - zgrazpof(ji,jj,jk)
+#else
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zgrazpoc(ji,jj,jk)
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zmortz2 - zgrazffe(ji,jj,jk)
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zgrazpof(ji,jj,jk)
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + ferat3 * zmortz2 &
+               &                     + unass2 * ( ferat3 * zgrazz(ji,jj,jk) + zgraznf(ji,jj,jk) &
+               &                     + zgrazf(ji,jj,jk) + zgrazpof(ji,jj,jk) + zgrazfff(ji,jj,jk) ) &
+               &                     - zgrazfff(ji,jj,jk)
+#endif
+
             END DO
          END DO
       END DO
       !
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('meso')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
    END SUBROUTINE p4z_meso
 
